#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include "DataStructures.h"
#include <map>

class MeshLoader 
{
protected:
	std::vector<Node> nodes; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::vector<FiniteElement> elements; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::vector<BoundaryFiniteElement> boundaryFEs; //!!! Плохой выбор контейнера - vector чем не подходит?

	std::unordered_set<Edge, std::hash<Edge>> edges;
public:
	virtual void LoadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;

	// ,   STL- ,     
	std::vector<Node> getNodes();
	std::vector<FiniteElement> getFiniteElements();
	std::vector<BoundaryFiniteElement> getBoundaryFiniteElements();

	// ,     ID    
	std::vector<FiniteElement> getElementsByID(int, int, int);

	// ,     ,    ID  
	std::vector<FiniteElement> getElementsByEdge(int, int);

	// ,      ID 
	std::vector<Node> getNodesByBoundary(int);

	// ,      ID 
	std::vector<FiniteElement> getElementsByBoundary(int);

	// ,       ID 
	std::vector<BoundaryFiniteElement> getsboundaryFEsByBoundary(int);

	// ,         
	void insertCenterNode();

	// ,  , n -            n
	std::vector<std::set<int>> getNodeNeighbours();

	// ,    Node, FiniteElement  BoundaryFiniteElement  
	void Print_Data();

	// ,     ID  
	std::vector<FiniteElement> getElementsByOneID(int);
	const std::vector<double>& findNodeRanges(int);
	std::vector<BoundaryFiniteElement> getTrianglesAndNodes(int);
	std::vector<Node>::iterator getNodeByID(int id);
	double square(Node A, Node B, Node C);
};